require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe "Editing an account" do
  include CoreHelper

  context "existing accounts" do
    before :each do
      create_account
    end

    it "should be able to edit the account's credentials" do
      STDIN.stubs(:gets).returns("newtest@test.com", "newpassword")
      Shacho::Account.edit(["test"])
      contents = get_credentials "#{Shacho::HEROKU_PREFIX}/accounts/test"
      email_test = contents[0] == "newtest@test.com"
      password_test = contents[1] == "newpassword"
      (email_test && password_test).should == true
    end
  end

  context "non-existing accounts" do
    it "should not be able to edit" do
      error = run_command("edit", ["rainbows"])
      error.class.should == RuntimeError
    end
  end
end
