require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe "Using an account" do
  include CoreHelper

  context "an existing account" do
    before :each do
      create_account
    end

    it "should be able to use an account" do
      Shacho::Account.use(["test"])
      current_creds = get_credentials("#{Shacho::HEROKU_PREFIX}")
      account_creds = get_credentials("#{Shacho::HEROKU_PREFIX}/accounts/test/")
      current_creds.should == account_creds
    end
  end

  context "a non-existing account" do
    it "should not be able to use" do
      error = run_command("use", ["rainbows"])
      error.class.should == RuntimeError
    end
  end
end
